#!/bin/sh
# I hate shell scripts
# Picscript 1.8.4
# Mark Kamichoff <prox@prolixium.com>

# http://www.die.net/doc/linux/abs-guide/contributed-scripts.html
# blank-rename.sh - Changes spaces and &'s to appropriate characters
# -----------------------
FOUND=0
for filename in *         #Traverse all files in directory.
do
	echo "$filename" | grep -q " "         #  Check whether filename
	if [ $? -eq $FOUND ]                   #+ contains space(s).
	then
		fname=$filename                      # Strip off path.
		n=`echo $fname | sed -e "s/ /_/g"`   # Substitute underscore for blank.
		n=`echo $n | sed -e "s/&/and/g"`   # Substitute & for "and"
		mv "$fname" "$n"	             # Do the actual renaming.
	fi
done 

# tolower()
for x in `ls -b1`
	do
	if [ ! -f $x ]; then
		continue
	fi
	if test '$x = Makefile'; then
		continue
	fi
	convert=`echo $x | tr '[A-Z]' '[a-z]'`
	if [ $convert != $x ]; then
		mv -i $x $convert
	fi
done

# Make dirs
if [ ! -d previews ]; then
	echo "Making previews dir ... ";
	mkdir previews
fi
if [ ! -d thumbs ]; then
	echo "Making thumbs dir ... ";
	mkdir thumbs
fi
if [ ! -d var ]; then
	echo "Making var dir ... ";
	mkdir var
fi

# Convert all image files
for TYPE in "JPG" "jpg" "JPEG" "jpeg" "PNG" "png"
do
	echo;
	echo "Processing $TYPE files ... ";

	THM=0
	PVW=0
	for x in `ls -b *.$TYPE 2> /dev/null`
		do
		if [ ! -f thumbs/$x ]; then
			# Make thumb
			echo -n "Making thumbs/$x ... ";
			convert -resize 160x120! $x thumbs/$x
			echo "done";
	
			THM=`expr $THM + 1`
		fi
	
		if [ ! -f previews/$x ]; then
	
			# Make preview
			echo -n "Making previews/$x ... ";
			convert -resize 800x600! $x previews/$x
			echo "done";
	
			PVW=`expr $PVW + 1`
		fi
	done
	echo " -> Created $THM $TYPE thumbnails.";
	echo " -> Created $PVW $TYPE previews.";
done

# Make blank descriptions, if it doesn't exist already
if [ ! -f var/descriptions.txt ]; then
	echo "Picture Gallery - Picscript 1.8.4" > var/descriptions.txt
	echo "default_descriptions" >> var/descriptions.txt
fi
